LoadAddOn("Ace3")
LoadAddOn("LibDataBroker-1.1")
LoadAddOn("LibDBIcon-1.0")
LoadAddOn("LibFuBarPlugin-3.0")

BossTalk = LibStub("AceAddon-3.0"):NewAddon("BossTalk", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0") 
local L = LibStub("AceLocale-3.0"):GetLocale("BossTalk")

BossTalk.cmdtable = { 
type='group',
args = { 
bossheader = {
type = 'header',
name = "BossTalk",
order = 1,
icon = "Interface\\Icons\\Ability_Druid_Berserk",
iconWidth = 30, 
iconHeight = 30,
},
shortcut = {
type = 'text',
name = L["Shortcut"],
desc = L["Enter an ID.\nExample for macro use, which would be Patchwerk in Naxxramas:\n|cff7fff7f/bosstalk shortcut 88|r"],
usage = "<ID>",
error = L["ID not found!"],
order = 1,
message = L["<macro mode>"],
get = false,
set = function(id)
BossTalk:Play(tonumber(id))
end,
validate = function(id)
return BossTalk.data[tonumber(id)]
end
},
search = {
type = 'text',
name = L["Search"],
desc = L["Example: If you enter the word \"die\", all quotations containing this word will be displayed."],
usage = "<words to search for>",
error = "Please enter more than 3 letters!",
order = 6,
message = "<search mode>",
get = false,
set = function(phrase)
BossTalk:Search(phrase)
end,
},
events = {
type = "group",
name = L["Events"],
desc = L["Boss quotes triggered by events."],
args = {
leben = { type = "group",
name = L["Low Health"],
desc = L["Quotes a boss when "]..L["your health is low."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 1,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "leben") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 2,
},
mana = { type = "group",
name = L["Low Mana"],
desc = L["Quotes a boss when "]..L["your mana is low."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 2,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "mana") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 3,
},	
pet = { type = "group",
name = L["Pet Attack"],
desc = L["Quotes a boss when "]..L["your pet is about to attack."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 2,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "pet") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 4,
},			
kampf = { type = "group",
name = L["Entering Combat"],
desc = L["Quotes a boss when "]..L["you enter combat."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 3,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "kampf") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 5,
},		
killingblow = { type = "group",
name = L["Killing Blow"],
desc = L["Quotes a boss when "]..L["you have scored a killing blow."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 2,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "killingblow") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 3,
},		
kumpeltot = { type = "group",
name = L["Party Member dies"],
desc = L["Quotes a boss when "]..L["a party member dies."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 4,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "kumpeltot") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 5,
},	
duell = { type = "group",
name = L["Duel Request"],
desc = L["Quotes a boss when "]..L["somebody requests a duel."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 6,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "duell") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 7,
},	
duellzwei = { type = "group",
name = L["Duel Finished"],
desc = L["Quotes a boss when "]..L["a duel is finished."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 8,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "duellzwei") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 9,
},																	
wiederleben = { type = "group",
name = L["Resurrection"],
desc = L["Quotes a boss when "]..L["when you ressurect from death."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 10,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "wiederleben") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 11,
},	
mount = { type = "group",
name = L["Mount"],
desc = L["Quotes a boss when "]..L["you summoned your mount."],
args = {
{ type = 'text',
name = L["Add Quote"],
desc = L["Adds a quote to this event.\nSimply enter an ID, which you can lookup in the boss menu.\n\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
usage = "<id>",
pass = true,
error = L["ID not found!"],
order = 8,
message = "Quote added.",
get = false,
set = function(id) BossTalk:AddEvent(tonumber(id), "mount") end,
validate = function(id) return BossTalk.data[tonumber(id)] end,
icon = "Interface\\Icons\\Spell_ChargePositive",
},								
},
order = 12,
},


custom = {
type = 'text',
name = L["|cffff8800Create custom event|r"],
desc = L["Enter the exact spell name.\nExample: |cff7fff7fEvocation|r"],
usage = "<Spell Name>",
order = 1,
get = false,
set = function(id)
	if BossTalk.db.global.events[id] then BossTalk:Print(L["Event already exists!"]) return end
	BossTalk.db.global.events[id]={}
	BossTalk:MakeEvent(id,1)
end,
},
																																																																																																						
},												
order = 2,
},
favourites ={
type = "group",
name = L["Favourites"],
desc = L["A list of your favourite quotes.\n|cff7fff7fshift-leftclick|r |cffff8800on a quote to remove that entry.|r"],
args = {},							
order = 5,
},
bosses = {
type = "group",
name = L["Bossquotes"],
desc = L["A list of bossquotes."],
args = {{ type = 'execute',
name = L["Generate menu!"],
desc = L["You have selected the memory-economic mode in the options menu, therefore you will need to generate the menu manually."],
func = function() BossTalk:GenerateMenu() end,
order = 1,
icon = "Interface\\Icons\\Spell_ChargePositive",
}},
order = 7,
},	
creditz = {
type = 'execute',
name = "|cff00ff00Credits|r",
desc = " ",
func = function() 
PlaySoundFile("Sound\\Character\\Draenei\\DraeneiMaleRoar01.wav", "Master")
for i=1,BossTalk:tcount(BossTalk.credits) do 
DEFAULT_CHAT_FRAME:AddMessage(BossTalk.credits[i]) 
end
local gilde = GetGuildInfo("player") 
if gilde == nil then
DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..UnitName("player").."|r |cffffff00of|r |cff00ff00"..GetRealmName().."|r |cffffff00for using BossTalk|r |cff00ff00:-)|r")
else
DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..UnitName("player").."|r |cffffff00of|r |cff00ff00<"..tostring(gilde).."> "..GetRealmName().."|r |cffffff00for using BossTalk|r |cff00ff00:-)|r")
end
end,
order = 13,
},	
spacemb = {
type = "header",
name = "  ",
desc = "  ",
order = 12,
},
FuBar = {
order = 11,
type = "group",
name = L["FuBar Options"],
desc = L["FuBar Options"],
hidden = function() return not IsAddOnLoaded("FuBar") end,
args = {				

showIcon = {
type = "toggle",
order = 3,
name = L["Show icon"],
desc = L["Show icon"],
get = function(info) return BossTalk:IsFuBarIconShown() end,
set = function(info, v) BossTalk:ToggleFuBarIconShown() end,
},
showText = {
type = "toggle",
order = 4,
name = L["Show text"],
desc = L["Show text"],
get = function(info) return BossTalk:IsFuBarTextShown() end,
set = function(info, v) BossTalk:ToggleFuBarTextShown() end,					
},
position = {
type = "group",
order = 5,
name = "Position",
desc = "Position",
args={
Left= {
type = 'execute',
name = L["Left"],
desc = " ",
get = function() return BossTalk:GetPanel() and BossTalk:GetPanel():GetPluginSide(BossTalk) end,
func = function() 
if BossTalk:GetPanel() and BossTalk:GetPanel().SetPluginSide then
BossTalk:GetPanel():SetPluginSide(BossTalk, "LEFT")
end
end,
},					
Right = {
type = 'execute',
name = L["Right"],
desc = " ",
func = function() 
if BossTalk:GetPanel() and BossTalk:GetPanel().SetPluginSide then
BossTalk:GetPanel():SetPluginSide(BossTalk, "RIGHT")
end
end,
},					
Center = {
type = 'execute',
name = L["Center"],
desc = " ",
func = function() 
if BossTalk:GetPanel() and BossTalk:GetPanel().SetPluginSide then
BossTalk:GetPanel():SetPluginSide(BossTalk, "CENTER")
end
end,
},																	
},
},
},
},																	
options = {
type = "group",
name = L["Options"],
desc = L["BossTalk's options menu."],
order = 8,
args = {
ignore = {
type = "group",
name = L["Blacklist options"],
desc = L["If you don't want to disable the entire sync ability, you can add players and/or yells to an ignore list."],
order = 5,
args = {
ignoppl = {
type = "group",
name = L["Ignore player"],
desc = L["Enter the name of a player you want to ignore. You will no longer receive any sync from that player."],
order = 3,
args = {		

},
},
ignoyell = {
type = "group",
name = L["Ignore yells"],
desc = L["Enter the ID of the yell you don't want to receive."],
order = 3,
args = {																						 			 																
},
},																						 
},},
syncopt = {
type = "group",
name = L["Sync Options"],
desc = L["Options for BossTalk's sync ability"],
order = 6,
args = {
synclocale = {
type = "toggle",
name = L["Only accept "]..GetLocale().." ("..L["User Yells"]..")",
desc = " ",
get  = function() return BossTalk.db.global.synclocale end,
set  = function() BossTalk.db.global.synclocale = not BossTalk.db.global.synclocale; end,
order = 1,
},
syncquiet = {
type = "toggle",
name = L["Receive sync silently "].." ("..L["User Yells"]..")",
desc = " ",
get  = function() return BossTalk.db.global.syncsilent end,
set  = function() BossTalk.db.global.syncsilent = not BossTalk.db.global.syncsilent; end,
order = 1,
},
dosync = {
type = "toggle",
name = L["Receive sync"],
desc = L["Plays the according sound file, when other people quote bosses |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.sync end,
set  = function() BossTalk.db.global.sync = not BossTalk.db.global.sync; end,
order = 2,
},
dosyncsend = {
type = "toggle",
name = L["Send sync"],
desc = L["Sync with other BossTalk users so that they can hear your sounds |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.sendsync end,
set  = function() BossTalk.db.global.sendsync = not BossTalk.db.global.sendsync; end,
order = 3,
},
dosyncevent = {
type = "toggle",
name = L["Receive event sync"],
desc = L["Plays the according sound file, when other people quote bosses triggered by events |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.syncevent end,
set  = function() BossTalk.db.global.syncevent = not BossTalk.db.global.syncevent; end,
order = 4,
},
dosynceventsend = {
type = "toggle",
name = L["Send event sync"],
desc = L["Sync with other BossTalk users so that they can hear your sounds which were triggered by events |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.sendsyncevent end,
set  = function() BossTalk.db.global.sendsyncevent = not BossTalk.db.global.sendsyncevent; end,
order = 5,
},	
					 															
showsync = {
type = "group",
name = L["Synclist"],
desc = L["A list of Players in Guild / Group who also use BossTalk."],
order = 10,
args = {		
},
},			    									  		
},
},        													
dosound = {
type = "toggle",
name = L["Play sound"],
desc = L["Plays the according sound file of the boss you quote |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.sound end,
set  = function() BossTalk.db.global.sound = not BossTalk.db.global.sound; end,
order = 1,
},												
dotext = {
type = "toggle",
name = L["Quote to chat"],
desc = L["\"Says\" or \"yells\" your bossquotes |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.text end,
set  = function() BossTalk.db.global.text = not BossTalk.db.global.text; end,
order = 2,
},

warnings = {
type = "toggle",
name = L["Disable world yell logging"],
desc = L["Enable this if you don't want new yells to be collected if you hear them. |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.worldlog end,
set  = function() BossTalk.db.global.worldlog = not BossTalk.db.global.worldlog; end,
order = 3,
},
nologging = {
type = "toggle",
name = L["Disable dungeon yell logging"],
desc = L["Enable this if you don't want new yells to be collected if you hear them. |cffff8800on/off|r"],
get  = function() return BossTalk.db.global.yelllog end,
set  = function() BossTalk.db.global.yelllog = not BossTalk.db.global.yelllog end,
order = 4,
},																
MinimapIcon = {
type = "toggle",
name = "Minimap button",
desc = " ",
order = 2,
get = function() return not BossTalk.db.global.MiniMap.hide end,
set = function()
BossTalk.db.global.MiniMap.hide = not BossTalk.db.global.MiniMap.hide
BossTalk:ToggleMM(BossTalk.db.global.MiniMap.hide)
end,
hidden = function() return IsAddOnLoaded("FuBar") end,
},
output = {
type = "group",
name = L["Output options"],
desc = L["Setup how you like to output chat messages."],
order = 6,
args = {

doyell = {
type = "toggle",
name = L["Yell"],
desc = L["Shall we yell the quotes?"],
get  = function() return BossTalk.db.global.yello end,
set  = function()
BossTalk.db.global.party = false;																 
BossTalk.db.global.raid = false;
BossTalk.db.global.guild = false;
BossTalk.db.global.say = false;
BossTalk.db.global.yello = true; 
BossTalk.db.global.emote = false;
BossTalk.db.global.howo = "YELL"; end,
order = 5,
},
doemote = {
type = "toggle",
name = L["Emote"],
desc = L["Shall we emote the quotes?"],
get  = function() return BossTalk.db.global.emote end,
set  = function()
BossTalk.db.global.party = false;																 
BossTalk.db.global.raid = false;
BossTalk.db.global.guild = false;
BossTalk.db.global.say = false;
BossTalk.db.global.yello = false; 
BossTalk.db.global.emote = true; 
BossTalk.db.global.howo = "EMOTE"; end,
order = 5,
},
dosay = {
type = "toggle",
name = L["Say"],
desc = L["Shall we say the quotes?"],
get  = function() return BossTalk.db.global.say end,
set  = function()
BossTalk.db.global.party = false;																 
BossTalk.db.global.raid = false;
BossTalk.db.global.guild = false;
BossTalk.db.global.say = true;
BossTalk.db.global.yello = false; 
BossTalk.db.global.emote = false;
BossTalk.db.global.howo = "SAY"; end,
order = 6,
},
doguild = {
type = "toggle",
name = L["Guild"],
desc = L["Shall we quote to guildchat?"],
get  = function() return BossTalk.db.global.guild end,
set  = function() 
BossTalk.db.global.party = false;																
BossTalk.db.global.raid = false;
BossTalk.db.global.guild = true;
BossTalk.db.global.say = false;
BossTalk.db.global.yello = false; 
BossTalk.db.global.emote = false;
BossTalk.db.global.howo = "GUILD"; end,
order = 7,
},
doraid = {
type = "toggle",
name = L["Raid"],
desc = L["Shall we quote to raidchat?"],
get  = function() return BossTalk.db.global.raid end,
set  = function()
BossTalk.db.global.party = false;																 
BossTalk.db.global.raid = true;
BossTalk.db.global.guild = false;
BossTalk.db.global.say = false;
BossTalk.db.global.yello = false; 
BossTalk.db.global.emote = false;
BossTalk.db.global.howo = "RAID"; end,
order = 8,
},	
doparty = {
type = "toggle",
name = L["Party"],
desc = L["Shall we quote to partychat?"],
get  = function() return BossTalk.db.global.party end,
set  = function() 
BossTalk.db.global.party = true;																
BossTalk.db.global.raid = false;
BossTalk.db.global.guild = false;
BossTalk.db.global.say = false;
BossTalk.db.global.yello = false; 
BossTalk.db.global.emote = false;
BossTalk.db.global.howo = "PARTY"; end,
order = 9,
},
spacy = { type = "header", name = " ", order= 10, },
doaddchat = {
type = "toggle",
name = L["Additional output"],
desc = L["If you set this option, your quotes will also be displayed in your default chat frame and the UI Errors Frame."],
get  = function() return BossTalk.db.global.otheroutput end,
set  = function() 
BossTalk.db.global.otheroutput = not BossTalk.db.global.otheroutput; end,														
order = 11,
},	
doaddothertop = {
type = "toggle",
name = L["Output incoming quotes"],
desc = L["If you set this option, other user's quotes will also be displayed in your default chat frame and the UI Errors Frame."],
get  = function() return BossTalk.db.global.othersyncoutput end,
set  = function() 
BossTalk.db.global.othersyncoutput = not BossTalk.db.global.othersyncoutput; end,																
order = 12,
},																																																																		 
},
},																
},
},		
},
}

BossTalk.credits = {
"|cffff1122BossTalk -Ace2-|r",
"|cffA843EFby Yvaine/Endeavour of EU Arthas|r updated by Bigbur & MysticalOS",
"|cff00ffffCredits:|r", 
"|cff00ff00Pernicius|r",
"|cff00ff00Lineya|r |cffffff00(english translation)|r",
"|cff00ff00Special thanks to|r |cffffff00Mokilok EU Frostmourne|r |cff00ff00for some great ideas\n and some well documented bug reports|r",
"|cff00ffffYells:|r", 
"|cff00ff00Elocin, Clonemaster, Seragorn, Lineya, Dreadfull, Structi, Bognari|r", 
"|cff00ff00Asole, Koak, Cl4nK, Chiqita/Hells\195\161ngel(EU Aegwynn), Moginheden|r", 
"|cff00ffffBetatesting:|r",  
"|cffffff00The guild |r|cff00ff00NEMESIS|r|cffffff00 EU Arthas|r",
"|cff00ff00Carcharoth(+Schildi!)|r |cffffff00EU Frostmourne|r",
"|cff00ff00Ashee|r |cffffff00EU Frostmourne|r",
"|cff00ff00Harakiwi|r |cffffff00EU Arthas|r",
"|cff00ff00Stern|r |cffffff00EU Arthas|r",
"|cff00ffffSpecial thanks to:|r", 
}